#!/bin/sh

echo "duration clients run tps"

d=$1
rn=$2

d2=$((d+10))

for c in 16 32 64 128 256 512 768 1000; do

	for r in `seq 1 5`; do

		killall -q pgbench

		psql test -c 'vacuum full' > /dev/null 2>&1
		psql test -c 'analyze' > /dev/null 2>&1
		psql test -c 'checkpoint' > /dev/null 2>&1

		# make sure xmin does not move (a little bit longer than read test too)
		# psql test -c "begin; select txid_current(); select pg_sleep($d2); commit" > /dev/null 2>&1 &

		echo "\set aid random(1, 10000 * :scale)
BEGIN;
UPDATE pgbench_accounts SET abalance = abalance + 1 WHERE aid = :aid;

-- throttle writes to 1000 tps
SELECT pg_sleep(1.0 / (1000.0/$c));
COMMIT;" > update.sql

		# make the write sessions a little bit longer than the read test
		pgbench -n -f update.sql -c $c -j 8 -M prepared -T $d2 test >> debug.log 2>&1 &

                # consume XIDs to move the xmax horizon beyond all the sleeping ones
                pgbench -n -f xid-commit.sql -c 1 -M prepared -T $d2 test > /dev/null 2>&1 &

		tps=`pgbench -n -c 1 -j 1 -f xid-select.sql -M prepared -T $d test | grep excluding | awk '{print $3}'`

		# wait for writes to complete
		wait

		echo $d $rn $c $r $tps

	done

done
